//  $Id: supertux.cpp,v 1.1 2006/05/02 23:56:57 ondra Exp $
// 
//  SuperTux
//  Copyright (C) 2004 Tobias Glaesser <tobi.web@gmx.de>
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.


//#include <sys/types.h>
#include <ctype.h>

#include "defines.h"
#include "globals.h"
#include "setup.h"
#include "intro.h"
#include "title.h"
#include "gameloop.h"
#include "leveleditor.h"
#include "screen.h"
#include "worldmap.h"
#include "resources.h"
#include "texture.h"
#include "tile.h"

#include "my_defs.h"

#ifdef _WIN32
extern void loadconfig(void);

int WINAPI WinMain(
HINSTANCE hInstance, 
HINSTANCE hPrevInstance, 
LPWSTR lpCmdLine, 
int nShowCmd 
) 
#else
int main(int argc, char * argv[])
#endif
{
  
  
  //MessageBox(NULL,L"2",L"1",0);
  //DBG("Debug opened ...");
  st_video_setup(false);
  st_hotkeys_unregister();	
  st_directory_setup();
#ifdef _WIN32_WCE
  loadconfig();
#endif
  //parseargs(argc, argv);
  
  st_audio_setup();
  //MessageBox(NULL,L"2",L"1",0);
  st_video_setup();
  //MessageBox(NULL,L"3",L"1",0);
  st_hotkeys_unregister();
  st_joystick_setup();
  //MessageBox(NULL,L"4",L"1",0);
  st_general_setup();
 // MessageBox(NULL,L"5",L"1",0);
  st_menu();
  //MessageBox(NULL,L"6",L"1",0);
  loadshared();
  //MessageBox(NULL,L"1",L"1",0);
  if (launch_leveleditor_mode && level_startup_file)
    {
    leveleditor(level_startup_file);
    }
  else if (level_startup_file)
    {
      GameSession session(level_startup_file, 1, ST_GL_LOAD_LEVEL_FILE);

      session.run();
    }
  else
    {  
      title();
    }
  
  clearscreen(0, 0, 0);
  updatescreen();

  unloadshared();
  st_general_free();
  TileManager::destroy_instance();
#ifdef DEBUG
  Surface::debug_check();
#endif
  st_shutdown();
  
  return 0;
}
